Index: src/uk/me/parabola/imgfmt/sys/ImgFS.java
===================================================================
--- src/uk/me/parabola/imgfmt/sys/ImgFS.java	(revision 4825)
+++ src/uk/me/parabola/imgfmt/sys/ImgFS.java	(working copy)
@@ -268,7 +268,7 @@
 		int bestBlockSize = 0;
 		int reserved = 0;
 		int sizeInBlocks = 0;
-		int bestSize = Integer.MAX_VALUE;
+		long bestSize = Integer.MAX_VALUE;
 
 		for (int blockSize = param.getBlockSize(); blockSize < (1 << 24); blockSize <<= 1) {
 			int headerSlotsRequired = 1;  // for the top level directory entry
@@ -290,7 +290,7 @@
 			int requiredSlots = param.getDirectoryStartEntry() + headerSlotsRequired;
 			int headerBlocks = (requiredSlots * ENTRY_SIZE + blockSize - 1) / blockSize;
 			int totalBlocks = headerBlocks + fileBlocks;
-			int size = totalBlocks * blockSize;
+			long size = (long) totalBlocks * blockSize;
 			log.infof("bs=%d, whole size=%d, hb=%d, fb=%d, blocks=%d", blockSize, size,
 					headerBlocks, fileBlocks, totalBlocks);
 
